load('exampleSudoku1.mat');
% this is how the sudoku looks like. 0 means value unknown:
ex

%% TODO: implement following function to get the matrix A.
A = sodokuRulesMatrix_template(); 

Iter = 500000;

f = zeros(9, 9, 9);
for i=1:9
    for j=1:9
        k = ex(i, j);
        if(k ~= 0)
            f(i, j, k) = 1;
        end
    end
end

%% Algorithm part.
L      = normest(A)^2;
tau     = 1/L;
E      = zeros(Iter,1);
u = zeros(size(A, 2), 1);

for k = 1:Iter
    % gradient descent
    grad    = A'*(A*u - 1);
    u       = u-tau*grad;
    
    % projection
    u       = max(0, min(1,u));
    u(f(:) == 1) = 1;
    
    % energys
    E(k) = 0.5*norm(A*u-1, 2)^2
end

%% show result
[~, u] = max(reshape(u, [9,9,9]), [],3);
u
  
figure;
plot(x,E(x))

